#!/usr/pkg/bin/perl -w
@wday = qw{ Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, };
@mon  = qw{ January February March April May June July August
		September October November December };
my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = localtime;
@date = ( $wday[$wday], $day, $mon[$mon], $year+1900 );

$count_file="/arpa/gm/m/mcsuper5/html/data/count_file";
$doc="source.pl";

($Arg, $PATHNAME) = split(/=/, $ENV{"QUERY_STRING"}, 2);
$FILENAME = $PATHNAME;
$FILENAME =~ s/.+\/([^\/]+)/$1/;
open HEADER, "../parts/header";
foreach (<HEADER>) {
    s{__TITLE__}{$FILENAME};
    s{__BCKGRND__}{/tiles/purple_marble.png};
    print $_;
}
close HEADER;

print qq|<h1>$FILENAME</h1><br />|;
print qq|<center><textarea id="code" class="code" style="width:95%;height:6.5in;" wrap="off" spellcheck="false" >|;
open CODE, $PATHNAME;
foreach (<CODE>) {
	s/&/&amp;/g;
	s/</&lt;/g;
	s/>/&gt;/g;
	print $_;
}
close CODE;
print qq|</textarea></center>|;
print qq|<p>This source has been viewed |;

open(CFILE, $count_file);
@counts=<CFILE>;
close(CFILE);

# Read the count file, pick the correct entry and increment it
$found = 0;
for $line (@counts) {
    chop ($line);
    ($page,$count)=split(/ /, $line);
        $page=~s/'//g;
        if ($page eq $doc)
        {
                $count++;
                $found = 1;
                $line = "'$page' $count";
                $found_count = $count;
        }
        push (@newcount, $line);
}
if ($found == 1) {
        $count = $found_count
} else {
        $count = 1;
        push (@newcount, "'$doc' 1");
}
@newcount=sort(@newcount);

# Updates the count file
open (CFILE, ">$count_file");
flock(CFILE, 2);        # lock
for $line (@newcount) { print CFILE "$line\n"; }
flock(CFILE, 8);        # unlock
close CFILE;

print "$count";

print qq| times.</p>|;
open FOOTER, "../parts/footer";
foreach (<FOOTER>) {
    s{__DATE__}{@date};
    print $_;
}
close FOOTER;
