#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int	get_var(char *assignment, char *variable, char *buffer);

/*
	get_var returns length of assignment, assignment - a ptr to a
	substring of buffer, which is the value of the assignment to
	variable. If variable is not defined in buffer, get_var returns
	EOF.
*/
int	get_var(char *assignment, char *variable, char *buffer) {
	char temp_buff[2048];
	char	*temp_ptr;
	char *end_ptr;
	char xvariable[255];

	strcpy(temp_buff, buffer);
	sprintf(xvariable, "%s=", variable);
	if (strncmp(temp_buff, xvariable, strlen(xvariable))) {
		sprintf(xvariable, "&%s=", variable);
		temp_ptr = strstr(temp_buff, xvariable);
	} else {
		temp_ptr = temp_buff;
	}
	if (temp_ptr) {
		temp_ptr = strchr(temp_ptr, '=');
		temp_ptr++;
		end_ptr = strchr(temp_ptr, '&');
		if (end_ptr) *end_ptr='\0';
		strcpy(assignment, temp_ptr);
		return (strlen(assignment));
	} else {
		strcpy(assignment, "");
		return EOF;
	}
} /* get_var */

